void setup() {                    // Fonction setup - début de l'exécution du programme,initialise et fixe les valeurs de démarrage du programme.
pinMode(3,OUTPUT);                // Fonction qui met la broche numérique 3 en sortie.
pinMode(4,OUTPUT);
Serial.begin(9600);               // Fonction qui définit le débit de données en bits par seconde (9600) pour la transmission de données en série avec le PC.
}

void loop() {                     // fonction qui s'éxécute en boucle et permet au programme de s'exécuter et de répondre.
int temps=1000;                   // permet de gérer la cadence de clignotemment : 1000 = 1 seconde.
char image[] = "0001100000111100011111101101101111111111001111000111111010100101"; // M
int longueur = strlen(image);     // strlen est une fonction qui renvoie la longueur de la chaîne de caractères (image).
for (int i=0;i<10;i++)            // signale le début de la "figure", avec clignotemant rapide pour i = 0 jusqu'à 9.
{ 
  digitalWrite(4,HIGH);           // Ecrire une valeur HAUTE ou BASSE à la broche 4. Si la broche a été configurée comme SORTIE avec pinMode(), sa tension sera réglée sur 5V pour HIGH ou 0V pour LOW.
  digitalWrite(3,HIGH);
  delay(temps/20);                // Suspendre le programme pour la durée (en millisecondes) spécifiée en paramètre.
  digitalWrite(4,LOW);
  digitalWrite(3,LOW);
  delay(temps/20);
}
Serial.println("");               // Imprime les données sur le port série sous la forme d'un texte ASCII lisible par un humain. Ici, saute une ligne.
Serial.println(""); 
delay(temps*2);

for (int i=0;i<longueur;i++)      // la boucle s'arrête après un nombre = "longueur" de passages.
{
  if (image[i]=='0')              // pour un pixel "Blanc".
  {
   digitalWrite(4,HIGH);              
   delay(temps);
   digitalWrite(4,LOW);
   delay(temps);
   Serial.print("   ");           // permet d'afficher 0 sans sauter de ligne.
 }
 else                             // pour un pixel "Noir".
 {
   digitalWrite(3,HIGH);          
   delay(temps);
   digitalWrite(3,LOW);
   delay(temps);
   Serial.print("X  ");           // permet d'afficher 1 sans sauter de ligne.
  }
  int mod = (i+1)%8;              // mod contient 0 si i+1 est multiple de 8.
  if (mod==0)              
  {
    Serial.println("");
   }
 }
}

