/* sketch Arduino utilisation d'un module hc-sr04
Autheur : Guillaume FLOCH
site web : www.osdclic.fr
tuto : www.memorandum.ovh
membre de : www.goldorhack.org
Modification et correction des commentaires JLP le 06/10/2017
*/

#define trigPin 5      //Trig 
#define echoPin 4      //Echo 
#define avertisseur 13 //Led
int mindist = 5; //On indique la distance (en cm) en dessous de laquelle nous souhaitons voir la led s'allumer

void setup() {
  Serial.begin (9600);  
  pinMode(trigPin, OUTPUT);  //On définit Trig comme une sortie
  pinMode(echoPin, INPUT);   //On définit Echo comme une entrée
  pinMode(avertisseur, OUTPUT); //On définit la led comme une sortie
}

void loop() {
  long duree, distance;
  digitalWrite(trigPin, LOW);  
  delayMicroseconds(2); 
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10); //Trig envoie pendant 10us 
  digitalWrite(trigPin, LOW);
  
  // On mesure le temps pour l'aller retour du signal
  duree = pulseIn(echoPin, HIGH); // pulseIn renvoie la durée en us pour recevoir un "front haut" sur la ligne echoPin
  // On calcule la distance en cm entre le détecteur et l'objet détecté
  distance = duree*340/(2*10000);  // "/2" est là pour éviter d'avoir l'aller + le retour, 
                                   //"10 000 = 1000 000 / 100" pour la conversion de us en seconde et la conversion m en cm
                                   // "340" est la vitesse du son dans l'air en m/s 
   
  if (distance < mindist) {  // On allume la led si on est moins loin que "mindist", mindist étant défini en début de programme
     digitalWrite(avertisseur,HIGH);
}
  else {   //sinon on éteind la led
    digitalWrite(avertisseur,LOW);
  }
  //Pour le moniteur série
  if ( distance <= 0){  
    Serial.println("Hors de portee"); // pas encore observé
  }
  else {
    Serial.print(distance);
    Serial.print(" cm ");
    Serial.print(duree);
    Serial.println(" ms");
  }
  delay(100);
}
