#include "DHT.h"

#define DHTPIN 2     // le numéro de la pin digital utilisée

#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321


// Initialise le capteur
DHT dht(DHTPIN, DHTTYPE);

void setup() {
  Serial.begin(9600);
  Serial.println("DHTxx test!");
  dht.begin();
}

void loop() {
  // Délai de 2 secondes entre les prise de la mesure
  delay(2000);

  // la lecture de la température et de l'humidité prend 250 millisecondes!
  // Le capteur peut lire les valeurs toutes les 2 secondes 
  float h = dht.readHumidity();
  // lit la temperature en Celsius (par défaut)
  float t = dht.readTemperature();
  // lire temperature en Fahrenheit (isFahrenheit = true)
  float f = dht.readTemperature(true);

  // Vérifie si la lecture est correcte (et recommence).
  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println("Impossible de lire le capteur!");
    return;
  }

  // Conversion en Fahrenheit (par défaut)
  float hif = dht.computeHeatIndex(f, h);
  // Compute heat index in Celsius (isFahreheit = false)
  float hic = dht.computeHeatIndex(t, h, false);

  Serial.print("Humidity: ");
  Serial.print(h);
  Serial.print(" %\t");
  Serial.print("Temperature: ");
  Serial.print(t);
  Serial.print(" *C ");
  Serial.println("");
}
