//=============================================================
// Confort dans la salle de classe
// Jean-Luc Pernette et Laurent GALLIEN
// Mesures de températures et humidités
// Sauvegarde des données sur carte SD
// 2017/2018
//=============================================================

#include <SD.h>
#include <SPI.h>
File myFile;
char namefile [] ="Mesures1.csv";
int pinCS = 10; // Pin 10 on Arduino Uno

#include "DHT.h"
#define DHTPIN 2        // le numéro de la pin digital utilisée
#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321

// Initialise le capteur
DHT dht(DHTPIN, DHTTYPE);

void setup() {
  pinMode(7,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(pinCS, OUTPUT); //Chipselect de l'adapteur de la carte SD
  Serial.begin(9600);
  
// Démarrage du programme
for (int i=0;i<10;i++)           
{ 
  digitalWrite(7,HIGH);
  digitalWrite(6,HIGH);           
  digitalWrite(5,HIGH);
  delay(50);                
  digitalWrite(7,LOW);
  digitalWrite(6,LOW);
  digitalWrite(5,LOW);
  delay(50);
}
  delay(1000);
  
     //SD Card Initialization
  if (SD.begin())
  { 
    Serial.println("SD card is ready to use.");
    digitalWrite(7,LOW);
  }
  
  else
  {
  Serial.println("SD card initialization failed");
  digitalWrite(7,HIGH);
  return;
 }
   
// Création du fichier, ouverture du fichier, mesure et enregistrement
for (int i=0;i<192;i++)
{
  digitalWrite(6,HIGH);
// DHT Initialization
  Serial.println("DHTxx test!");
  dht.begin();

 // Délai de 2,5 secondes entre les prise de la mesure
  delay(2500);
  myFile = SD.open(namefile, FILE_WRITE);
  delay(2500);
  // la lecture de la température et de l'humidité prend 250 millisecondes!
  // Le capteur peut lire les valeurs toutes les 2,5 secondes 
  float h = dht.readHumidity();
  // lit la temperature en Celsius (par défaut)
  float t = dht.readTemperature();
 
  // Vérifie si la lecture est correcte (et recommence).
  if (isnan(h) || isnan(t)) {
    Serial.println("Impossible de lire le capteur!");
    return;
  }

  Serial.print("Humidity: ");
  Serial.print(h);
  Serial.print(" %\t");
  Serial.print("Temperature: ");
  Serial.print(t);
  Serial.print(" °C ");
  Serial.println("");

  delay(5000);
  
 
  // if the file opened okay, write to it:
  if (myFile) {
    Serial.println("Writing to file...");
    // Write to file
    float temps=millis();
    myFile.print(i);
    myFile.print(";");
    myFile.print(t);
    myFile.print(";");
    myFile.print(h);
    myFile.print(";");
    myFile.println(temps);
    Serial.print("Mesure N°");
    Serial.println(i);
    Serial.print("\t Humidity: ");
    Serial.print(h);
    Serial.print(" %\t");
    Serial.print("Temperature: ");
    Serial.print(t);
    Serial.print(" °C\t");
    Serial.println(temps);
    Serial.println("Done.");
  }
  // if the file didn't open, print an error:
  else {
    Serial.println("error opening file");
       }
   myFile.close(); // Ferme le fichier
for (int j=0;j<178;j++)
{
  delay(1250);
  digitalWrite(6,LOW);
  delay(1250);
  digitalWrite(5,HIGH);
  delay(1250);
  digitalWrite(5,LOW);
  delay(1250);
  digitalWrite(6,HIGH);
}
   }
  // Lecture du fichier
  myFile = SD.open(namefile);
  if (myFile) {
    Serial.println("Read:");
    // Reading the whole file
    while (myFile.available()) {
      Serial.write(myFile.read());
   }
    myFile.close();
  digitalWrite(5,HIGH);}
  else {
  Serial.println("error opening file");
}
digitalWrite(6,LOW);
}

void loop() {
}

