/*Exploitation d'un télémètre pour réaliser un passsage piéton intelligent en lien avec la vidéo : https://www.youtube.com/watch?v=mI9L9os-v2A
 * Par Laurent Gallien et Jean-Luc Pernette
 * Groupe IREM Cycle 3,4 et LP
 * Formation 16 novembre 2017 - IREM Dijon
 */
/* sketch Arduino utilisation d'un module hc-sr04
Autheur : Guillaume FLOCH
site web : www.osdclic.fr
tuto : www.memorandum.ovh
membre de : www.goldorhack.org
Modification et correction des commentaires JLP le 06/10/2017
*/

#define rouge 11      // Feu rouge pour voiture
#define jaune 12      // Feu jaune pour voiture
#define vert 13       // Feu verte pour voiture
#define prouge 8      // Feu rouge pour piéton
#define pvert 9       // Feu rouge pour piéton
#define trigPin 5     //Trig du télémètre
#define echoPin 4     //Echo du télémètre 

int mindist = 15;      //On indique la distance (en cm) en dessous de laquelle nous souhaitons voir la led s'allumer
int voiture = 1;       //Priorité aux voitures (feu vert pour les voitures et rouge pour les piètons à l'initialisation du système
long temps = 0;
  
void setup() {
  Serial.begin (9600);  
  pinMode(trigPin, OUTPUT);  //On définit Trig comme une sortie
  pinMode(echoPin, INPUT);   //On définit Echo comme une entrée
  pinMode(rouge, OUTPUT); //On définit la led comme une sortie
  pinMode(jaune, OUTPUT); //On définit la led comme une sortie
  pinMode(vert, OUTPUT); //On définit la led comme une sortie
  pinMode(prouge, OUTPUT); //On définit la led comme une sortie
  pinMode(pvert, OUTPUT); //On définit la led comme une sortie
  // Initialisation des variables
  digitalWrite(pvert,LOW); 
  digitalWrite(prouge,HIGH);
  digitalWrite(rouge,LOW);
  digitalWrite(jaune,LOW);
  digitalWrite(vert,HIGH);
}

int detection()
  {
    long duree, distance;
    digitalWrite(trigPin, LOW);  
    delayMicroseconds(2); 
    digitalWrite(trigPin, HIGH);
    delayMicroseconds(10); //Trig envoie pendant 10us 
    digitalWrite(trigPin, LOW);
    // On mesure le temps pour l'aller retour du signal
    duree = pulseIn(echoPin, HIGH); // pulseIn renvoie la durée en us pour recevoir un "front haut" sur la ligne echoPin
    // On calcule la distance en cm entre le détecteur et l'objet détecté
    distance = duree*340/(2*10000);  // "/2" est là pour éviter d'avoir l'aller + le retour, 
                                     //"10 000 = 1000 000 / 100" pour la conversion de us en seconde et la conversion m en cm
                                     // "340" est la vitesse du son dans l'air en m/s 
   
    if (distance < mindist ) {  // On teste si le piéton est à moins de 5 cm donc souhaite traverser
       //Pour le moniteur série
       Serial.println ("Il y a quelqu'un prêt à traverser");
       return 1;
       }
    else {   //sinon on éteind la led
      //Pour le moniteur série
      Serial.println ("Il n'y a pas de piéton");
      return 0;
      }
  }

void loop() {
    int d;
    if (temps<10000) {
      d = detection();
      if ((voiture == 1) && (d == 1)) {  // && est la fonction ET du langage Arduino
          digitalWrite(vert,LOW);
          digitalWrite(jaune,HIGH);
          delay(1000);
          temps=1000;
          digitalWrite(jaune,LOW);
          digitalWrite(rouge,HIGH);
          voiture=0;
          while (d==1) {  // On teste si le piéton est à moins de 5 cm donc souhaite traverser
            Serial.println("Il y a quelqu'un prêt à traverser - Dans boucle WHILE");
            delay(1000);
            digitalWrite(prouge,LOW);
            digitalWrite(pvert,HIGH);
            d=detection();
            delay(1000);
            temps=0;
          }  
      }
      else {
        while (d == 1) {  // On teste si le piéton est à moins de 5 cm donc souhaite traverser
           digitalWrite(prouge,LOW);
           digitalWrite(pvert,HIGH);
           Serial.println("Il y a quelqu'un prêt à traverser - Dans boucle WHILE");
           delay(1000);
           d=detection();
           temps=0;
         }
     }
     Serial.println("Il n'y a pas de piéton - Sortie WHILE");
     digitalWrite(pvert,LOW);
     digitalWrite(prouge,HIGH);
     delay(500);
     digitalWrite(rouge,LOW);
     digitalWrite(vert,HIGH);
     voiture=1;
     temps=temps+1000;
     Serial.print("temps total =");
     Serial.println(temps);
    }
    else {
      d=detection();    
      if ((temps>10000)&&(d==0)) {
        while (d==0) {
             if (temps <20000) {
                digitalWrite(rouge,LOW);
                digitalWrite(vert,LOW);
                digitalWrite(prouge,LOW);
                digitalWrite(jaune,HIGH);
                delay(500);
                digitalWrite(jaune,LOW);
                delay(500);
                d=detection();
                temps=temps+1000;
                Serial.print("temps total =");
                Serial.println(temps);
              }
              else {
                delay(1000);
                temps=temps+1000;
                d=detection();
                Serial.print("temps total =");
                Serial.println(temps);
              }
             
        }
        digitalWrite(prouge,HIGH);
        digitalWrite(jaune,HIGH);
        delay(500);
        digitalWrite(jaune,LOW);
        digitalWrite(rouge,HIGH);
        voiture=0;
        temps=0;
      }
     temps=temps+1000;
     Serial.print("temps total =");
     Serial.println(temps); 
     delay(1000);
    }
}
